using System.Drawing;
using System.Drawing.Imaging;
using Microsoft.DirectX.Direct3D;

namespace RPGOnline.Controls.Map.Layers
{
    public class OverlayLayer : MapLayer
    {

        public OverlayLayer(Device device, Map map) : base(device, "Overlay", map)
        {
        }

        protected override void DrawTile(MapCell tile, int x, int y)
        {
            if (tile.Frames.Count == 0)
                return;

            m_device.RenderState.AlphaBlendEnable = true;

            tile.Frame.Draw(m_device, x, y, 200);

            m_device.RenderState.AlphaBlendEnable = false;
        }
    }
}